# Irishman

![Pub Likes](https://img.shields.io/pub/likes/irishman)
![Pub Points](https://img.shields.io/pub/points/irishman)
![GitHub code size in bytes](https://img.shields.io/github/languages/code-size/fairfield-programming/irishman?color=yellow)
![GitHub contributors](https://img.shields.io/github/contributors/fairfield-programming/irishman)
![GitHub top language](https://img.shields.io/github/languages/top/fairfield-programming/irishman?color=orange)

🇮🇪 A generic programming language interpreter, linter, formatter, and all that jazz, written in Dart.

## Installation

To install this package as a library in Dart, just run the following command in the directory of your project.

### With Dart

```bash
dart pub add irishman
```

### With Flutter

```bash
flutter pub add irishman
```

## How does it work?

_To get redirected to the documentation for the project, [click here](https://pub.dev/documentation/irishman/latest/)._

The whole idea of irishman is to emulate other programming languages in a lightweight manner. Currently, a majority of code execution platforms have a number of language runtimes installed on their machines, and they simply run the code. That is not how irishman works. Irishman works by defining a schema for all programming languages. From there, each language can be referenced and code can be run within it using the irishman emulator. Irishman gives you the keys at every step. So, if you would like to read through the AST, list of tokens, or redefine a languages standard library, you are given full access to do so. On top of being a runtime, Irishman has several utility features such as generating standard library documentation, linting code, building syntax highlighting schemas, etc.
